"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseEVMExternalStateProvider = void 0;
var crypto_rpc_1 = require("crypto-rpc");
var lodash_1 = __importDefault(require("lodash"));
var config_1 = __importDefault(require("../../../../config"));
var logger_1 = __importDefault(require("../../../../logger"));
var stats_1 = require("../../../../utils/stats");
var moralis_1 = __importDefault(require("../../external/moralis"));
var internal_1 = require("../../internal/internal");
var transaction_1 = require("../models/transaction");
var csp_1 = require("./csp");
var provider_1 = require("./provider");
var BaseEVMExternalStateProvider = /** @class */ (function (_super) {
    __extends(BaseEVMExternalStateProvider, _super);
    function BaseEVMExternalStateProvider(chain) {
        if (chain === void 0) { chain = 'ETH'; }
        var _this = _super.call(this, chain) || this;
        _this.chain = chain;
        _this.config = config_1.default.chains[_this.chain];
        return _this;
    }
    BaseEVMExternalStateProvider.prototype.getWeb3 = function (network, params) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var e_1, dataType, providerConfig, rpcConfig, rpc;
            var _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 3, , 4]);
                        if (!(0, provider_1.isValidProviderType)(params === null || params === void 0 ? void 0 : params.type, (_b = (_a = csp_1.BaseEVMStateProvider.rpcs[this.chain]) === null || _a === void 0 ? void 0 : _a[network]) === null || _b === void 0 ? void 0 : _b.dataType)) return [3 /*break*/, 2];
                        return [4 /*yield*/, csp_1.BaseEVMStateProvider.rpcs[this.chain][network].web3.eth.getBlockNumber()];
                    case 1:
                        _d.sent();
                        _d.label = 2;
                    case 2: return [3 /*break*/, 4];
                    case 3:
                        e_1 = _d.sent();
                        delete csp_1.BaseEVMStateProvider.rpcs[this.chain][network];
                        return [3 /*break*/, 4];
                    case 4:
                        if (!csp_1.BaseEVMStateProvider.rpcs[this.chain] || !csp_1.BaseEVMStateProvider.rpcs[this.chain][network]) {
                            logger_1.default.info("Making a new connection for ".concat(this.chain, ":").concat(network));
                            dataType = params === null || params === void 0 ? void 0 : params.type;
                            providerConfig = (0, provider_1.getProvider)({ network: network, dataType: dataType, config: this.config });
                            rpcConfig = __assign(__assign({}, providerConfig), { chain: 'ETH', currencyConfig: {} });
                            rpc = new crypto_rpc_1.CryptoRpc(rpcConfig, {}).get('ETH');
                            if (csp_1.BaseEVMStateProvider.rpcs[this.chain]) {
                                csp_1.BaseEVMStateProvider.rpcs[this.chain][network] = { rpc: rpc, web3: rpc.web3, dataType: dataType || 'combinded' };
                            }
                            else {
                                csp_1.BaseEVMStateProvider.rpcs[this.chain] = (_c = {}, _c[network] = { rpc: rpc, web3: rpc.web3, dataType: dataType || 'combinded' }, _c);
                            }
                        }
                        return [2 /*return*/, csp_1.BaseEVMStateProvider.rpcs[this.chain][network]];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getLocalTip = function (_a) {
        var chain = _a.chain, network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            var web3, block;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getWeb3(network)];
                    case 1:
                        web3 = (_b.sent()).web3;
                        return [4 /*yield*/, web3.eth.getBlock('latest')];
                    case 2:
                        block = _b.sent();
                        return [2 /*return*/, this.transformBlockData({ chain: chain, network: network, block: block })];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getFee = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var network, _a, target, web3, latestBlock, feeHistory, gasPrices, whichQuartile, quartileMedian, roundedGwei, gwei, feerate;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        network = params.network, _a = params.target, target = _a === void 0 ? 4 : _a;
                        return [4 /*yield*/, this.getWeb3(network, { type: 'historical' })];
                    case 1:
                        web3 = (_b.sent()).web3;
                        return [4 /*yield*/, web3.eth.getBlockNumber()];
                    case 2:
                        latestBlock = _b.sent();
                        return [4 /*yield*/, web3.eth.getFeeHistory(20 * 200, latestBlock, [25])];
                    case 3:
                        feeHistory = _b.sent();
                        gasPrices = feeHistory.reward.map(function (reward) { return parseInt(reward[0]); }).sort(function (a, b) { return b - a; });
                        whichQuartile = Math.min(target, 4) || 1;
                        quartileMedian = stats_1.StatsUtil.getNthQuartileMedian(gasPrices, whichQuartile);
                        roundedGwei = (quartileMedian / 1e9).toFixed(2);
                        gwei = Number(roundedGwei) || 0;
                        feerate = gwei * 1e9;
                        return [2 /*return*/, { feerate: feerate, blocks: target }];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlocks = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain_1, network_1, query, web3_1, tip, tipHeight_1, blockTransform, batch_1, blockPromises, blockNumbers_1, _loop_1, i, error_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 4, , 5]);
                        chain_1 = params.chain, network_1 = params.network;
                        return [4 /*yield*/, this.getBlocksParams(params)];
                    case 1:
                        query = (_a.sent()).query;
                        return [4 /*yield*/, this.getWeb3(network_1, { type: 'historical' })];
                    case 2:
                        web3_1 = (_a.sent()).web3;
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 3:
                        tip = _a.sent();
                        tipHeight_1 = tip ? tip.height : 0;
                        blockTransform = function (block) { return __awaiter(_this, void 0, void 0, function () {
                            var confirmations, blockHeight, convertedBlock;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, block];
                                    case 1:
                                        block = _a.sent();
                                        confirmations = 0;
                                        blockHeight = block.height || block.number || 0;
                                        if (blockHeight >= 0) {
                                            confirmations = tipHeight_1 - blockHeight + 1;
                                        }
                                        convertedBlock = this.transformBlockData({ chain: chain_1, network: network_1, block: block });
                                        return [2 /*return*/, __assign(__assign({}, convertedBlock), { confirmations: confirmations })];
                                }
                            });
                        }); };
                        batch_1 = new web3_1.eth.BatchRequest();
                        blockPromises = [];
                        blockNumbers_1 = lodash_1.default.range(query.startBlock, query.endBlock + 1);
                        _loop_1 = function (i) {
                            var blockPromise = new Promise(function (resolve, reject) {
                                batch_1.add(web3_1.eth.getBlock.request(blockNumbers_1[i], function (error, block) {
                                    if (error) {
                                        return reject(error);
                                    }
                                    return resolve(block);
                                }));
                            });
                            blockPromises.push(blockPromise);
                        };
                        // batch getBlock requests to reduce latency
                        for (i = 0; i < blockNumbers_1.length; i++) {
                            _loop_1(i);
                        }
                        ;
                        batch_1.execute();
                        return [2 /*return*/, Promise.all(blockPromises)
                                .then(blockPromises.map(blockTransform))
                                .catch(function (error) { return error; })];
                    case 4:
                        error_1 = _a.sent();
                        console.error(error_1);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/, undefined];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getTransaction = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, txId, web3, tip, tipHeight, tx, confirmations, _a, receipt, fee, tansformedTx, convertedTx, err_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 8, , 9]);
                        chain = params.chain, network = params.network, txId = params.txId;
                        if (typeof txId !== 'string' || !chain || !network) {
                            throw new Error('Missing required param');
                        }
                        network = network.toLowerCase();
                        return [4 /*yield*/, this.getWeb3(network, { type: 'historical' })];
                    case 1:
                        web3 = (_b.sent()).web3;
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 2:
                        tip = _b.sent();
                        tipHeight = tip ? tip.height : 0;
                        return [4 /*yield*/, web3.eth.getTransaction(txId)];
                    case 3:
                        tx = _b.sent();
                        if (!tx) return [3 /*break*/, 6];
                        confirmations = 0;
                        if (tx.blockNumber && tx.blockNumber >= 0) {
                            confirmations = tipHeight - tx.blockNumber + 1;
                        }
                        _a = tx;
                        return [4 /*yield*/, this.getBlockTimestamp(tx.blockHash, params)];
                    case 4:
                        _a.blockTime = _b.sent();
                        return [4 /*yield*/, web3.eth.getTransactionReceipt(txId)];
                    case 5:
                        receipt = _b.sent();
                        if (receipt) {
                            fee = receipt.gasUsed * parseInt(tx.gasPrice);
                            tx.receipt = receipt;
                            tx.fee = fee;
                        }
                        tansformedTx = this.transformTransactionData({ tx: tx, network: network, chain: chain });
                        convertedTx = transaction_1.EVMTransactionStorage._apiTransform(tansformedTx, { object: true });
                        return [2 /*return*/, __assign(__assign({}, convertedTx), { confirmations: confirmations })];
                    case 6: return [2 /*return*/, undefined];
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        err_1 = _b.sent();
                        console.error(err_1);
                        return [3 /*break*/, 9];
                    case 9: return [2 /*return*/, undefined];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getWalletBalanceAtTime = function (_params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new Error('Method not implemented.');
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.streamBlocks = function (_params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new Error('Method not implemented.');
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.streamAddressTransactions = function (_params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new Error('Method not implemented.');
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.streamTransactions = function (_params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw new Error('Method not implemented.');
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlockTimestamp = function (blockNumber, _a) {
        var network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            var web3, block;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getWeb3(network)];
                    case 1:
                        web3 = (_b.sent()).web3;
                        return [4 /*yield*/, web3.eth.getBlock(blockNumber)];
                    case 2:
                        block = _b.sent();
                        return [2 /*return*/, new Date(Number(block.timestamp) * 1000)];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlocksParams = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var chain, network, sinceBlock, blockId, _a, args, startDate, endDate, date, since, direction, paging, _b, limit, _c, sort, options, query, height, height, _d, _e, _f, _g, firstDate, nextDate, _h, _j, _k, _l, blockNum, blockNum, tip, tipHeight, endBlock, startBlock, b;
            return __generator(this, function (_m) {
                switch (_m.label) {
                    case 0:
                        chain = params.chain, network = params.network, sinceBlock = params.sinceBlock, blockId = params.blockId, _a = params.args, args = _a === void 0 ? {} : _a;
                        startDate = args.startDate, endDate = args.endDate, date = args.date, since = args.since, direction = args.direction, paging = args.paging;
                        _b = args.limit, limit = _b === void 0 ? 10 : _b, _c = args.sort, sort = _c === void 0 ? { height: -1 } : _c;
                        options = { limit: limit, sort: sort, since: since, direction: direction, paging: paging };
                        query = { startBlock: 0, endBlock: 0 };
                        if (!chain || !network) {
                            throw new Error('Missing required param');
                        }
                        if (blockId) {
                            if (blockId.length >= 64) {
                                query['block'] = blockId;
                            }
                            else {
                                height = parseInt(blockId, 10);
                                if (Number.isNaN(height) || height.toString(10) !== blockId) {
                                    throw new Error('invalid block id provided');
                                }
                                query['height'] = height;
                            }
                        }
                        if (sinceBlock) {
                            height = Number(sinceBlock);
                            if (Number.isNaN(height) || height.toString(10) !== sinceBlock) {
                                throw new Error('invalid block id provided');
                            }
                            query['height'] = height;
                        }
                        if (!startDate) return [3 /*break*/, 2];
                        _d = query;
                        _e = 'startDateBlock';
                        return [4 /*yield*/, this.getBlockNumberByDate({ date: startDate, network: network })];
                    case 1:
                        _d[_e] = _m.sent();
                        _m.label = 2;
                    case 2:
                        if (!endDate) return [3 /*break*/, 4];
                        _f = query;
                        _g = 'endDateBlock';
                        return [4 /*yield*/, this.getBlockNumberByDate({ date: endDate, network: network })];
                    case 3:
                        _f[_g] = _m.sent();
                        _m.label = 4;
                    case 4:
                        if (!date) return [3 /*break*/, 7];
                        firstDate = new Date(date);
                        nextDate = new Date(date);
                        nextDate.setDate(nextDate.getDate() + 1);
                        _h = query;
                        _j = 'startDateBlock';
                        return [4 /*yield*/, this.getBlockNumberByDate({ date: firstDate, network: network })];
                    case 5:
                        _h[_j] = _m.sent();
                        _k = query;
                        _l = 'endDateBlock';
                        return [4 /*yield*/, this.getBlockNumberByDate({ date: nextDate, network: network })];
                    case 6:
                        _k[_l] = _m.sent();
                        _m.label = 7;
                    case 7:
                        if (!((query === null || query === void 0 ? void 0 : query.block) && (query === null || query === void 0 ? void 0 : query.height))) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.getBlockNumberByBlockId({ blockId: query.block, network: network })];
                    case 8:
                        blockNum = _m.sent();
                        if (!blockNum) {
                            throw new Error("Could not get block ".concat(query.block));
                        }
                        query.startBlock = blockNum;
                        query.endBlock = blockNum + query.height;
                        _m.label = 9;
                    case 9:
                        if (!(!(query === null || query === void 0 ? void 0 : query.block) && (query === null || query === void 0 ? void 0 : query.height))) return [3 /*break*/, 11];
                        return [4 /*yield*/, this.getBlockNumberByBlockId({ blockId: query.height, network: network })];
                    case 10:
                        blockNum = _m.sent();
                        if (!blockNum) {
                            throw new Error("Could not get block ".concat(query.block));
                        }
                        query.startBlock = blockNum;
                        _m.label = 11;
                    case 11:
                        if (query === null || query === void 0 ? void 0 : query.startDateBlock) {
                            query.startBlock = query.startDateBlock;
                        }
                        if (query === null || query === void 0 ? void 0 : query.endDateBlock) {
                            query.endBlock = query.endDateBlock;
                        }
                        return [4 /*yield*/, this.getLocalTip(params)];
                    case 12:
                        tip = _m.sent();
                        tipHeight = tip ? tip.height : 0;
                        endBlock = query.endBlock || tipHeight;
                        startBlock = query.startBlock || endBlock - 1;
                        if (limit && limit > 0 && (endBlock - startBlock) > limit) {
                            endBlock = startBlock + limit;
                        }
                        if (sort === -1) {
                            b = startBlock;
                            startBlock = endBlock;
                            endBlock = b;
                        }
                        // { limit, sort, since, direction, paging };
                        return [2 /*return*/, { query: query, options: options }];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlockNumberByDate = function (_a) {
        var date = _a.date, network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            var res, block;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, moralis_1.default.getBlockByDate({ chain: this.chain, network: network, date: date })];
                    case 1:
                        res = _b.sent();
                        block = JSON.parse(res.body);
                        return [2 /*return*/, block.number ? Number(block.number) : undefined];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.getBlockNumberByBlockId = function (_a) {
        var blockId = _a.blockId, network = _a.network;
        return __awaiter(this, void 0, void 0, function () {
            var res, block;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, moralis_1.default.getBlockByHash({ chain: this.chain, network: network, blockId: blockId })];
                    case 1:
                        res = _b.sent();
                        block = JSON.parse(res.body);
                        return [2 /*return*/, block.number ? Number(block.number) : undefined];
                }
            });
        });
    };
    BaseEVMExternalStateProvider.prototype.transformBlockData = function (_a) {
        var chain = _a.chain, network = _a.network, block = _a.block;
        return {
            chain: chain,
            network: network,
            height: block.number,
            hash: block.hash,
            time: new Date(block.timestamp),
            timeNormalized: new Date(block.timestamp),
            previousBlockHash: block.parentHash,
            nextBlockHash: '',
            transactionCount: block.transactions.length,
            size: block.size,
            reward: 5,
            processed: true,
            nonce: block.nonce,
            difficulty: block.difficulty,
            gasUsed: block.gasUsed,
            gasLimit: block.gasLimit,
            baseFeePerGas: block.baseFeePerGas // BigNumber
        }; // IEVMBlock
    };
    BaseEVMExternalStateProvider.prototype.transformTransactionData = function (_a) {
        var chain = _a.chain, network = _a.network, tx = _a.tx;
        return {
            txid: tx.hash,
            chain: chain,
            network: network,
            blockHeight: tx.blockNumber,
            blockHash: tx.blockHash,
            blockTime: tx.blockTime,
            blockTimeNormalized: tx.blockTimeNormalized,
            fee: tx.fee,
            value: tx.value,
            gasLimit: tx.gasLimit,
            gasPrice: tx.gasPrice,
            nonce: tx.nonce,
            to: tx.to,
            from: tx.from,
            data: tx.data,
            effects: tx.effects,
        };
    };
    return BaseEVMExternalStateProvider;
}(internal_1.InternalStateProvider));
exports.BaseEVMExternalStateProvider = BaseEVMExternalStateProvider;
//# sourceMappingURL=ecsp.js.map